-- the abilities

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "anyonelegacy"
			
			if player.abilitypicked == nil //Checks if they have an ability.
				player.abilitypicked = 0
			end
			
			if player.abilityselect == nil //DECIDES YOUR FATE
				player.abilityselect = 0
			end
			
			-- updated to include new abilities
			if player.mo.health 
			and player.abilitypicked == 0 //If your ability is not picked...
				player.abilityselect = $1 + P_RandomRange(1, 14) //Pick one!
				player.abilitypicked = 1
			end
			
			if not player.mo.health //Reset on death!
				player.abilitypicked = 0
				player.abilityselect = 0
			end
			
			//Abilities!
			-- all abilities have been updated to only overwrite color if the command for it is on
			
			-- what is this for
			if player.abilityselect == 0
				player.normalspeed = 20*FRACUNIT
				player.actionspd = 0*FRACUNIT
				player.runspeed = 34*FRACUNIT
				player.acceleration = 40
				player.accelstart = 96
				player.thrustfactor = 3
				player.jumpfactor = 20*FRACUNIT
				player.charability = CA_NONE
				player.charability2 = CA2_NONE
				if player.anycolor
					player.mo.color = SKINCOLOR_GREY
				end
			end
			
			-- sonic
			-- updated to 2.2 stats, changed color to regular blue
			if player.abilityselect == 1
				player.normalspeed = 36*FRACUNIT
				player.actionspd = 60*FRACUNIT
				player.runspeed = 28*FRACUNIT
				player.acceleration = 40
				player.accelstart = 96
				player.thrustfactor = 5
				player.jumpfactor = 1*FRACUNIT
				player.charability = CA_THOK
				player.charability2 = CA2_SPINDASH
				if player.anycolor
					player.mo.color = SKINCOLOR_BLUE
				end
			end
			
			-- tails
			-- updated to 2.2 stats
			if player.abilityselect == 2
				player.normalspeed = 36*FRACUNIT
				player.actionspd = 100*FRACUNIT
				player.runspeed = 28*FRACUNIT
				player.acceleration = 40
				player.accelstart = 96
				player.thrustfactor = 5
				player.jumpfactor = 1*FRACUNIT
				player.charability = CA_FLY
				player.charability2 = CA2_SPINDASH
				if player.anycolor
					player.mo.color = SKINCOLOR_ORANGE
				end
			end
			
			-- knuckles
			-- updated to 2.2 stats
			-- bust walls flag is added in a separate loop below
			if player.abilityselect == 3
				player.normalspeed = 36*FRACUNIT
				player.actionspd = 25*FRACUNIT
				player.runspeed = 28*FRACUNIT
				player.acceleration = 40
				player.accelstart = 96
				player.thrustfactor = 5
				player.jumpfactor = skins["knuckles"].jumpfactor
				player.charability = CA_GLIDEANDCLIMB
				player.charability2 = CA2_SPINDASH
				if player.anycolor
					player.mo.color = SKINCOLOR_RED
				end
			end
			
			-- legacy metal sonic
			-- changed color to cornflower
			if player.abilityselect == 4
				player.normalspeed = 36*FRACUNIT
				player.actionspd = 50*FRACUNIT
				player.runspeed = 34*FRACUNIT
				player.acceleration = 37
				player.accelstart = 104
				player.thrustfactor = 6
				player.jumpfactor = 1*FRACUNIT
				player.charability = CA_JUMPBOOST
				player.charability2 = CA2_SPINDASH
				if player.anycolor
					player.mo.color = SKINCOLOR_CORNFLOWER
				end
			end
			
			-- legacy amy
			-- gave spindash to prevent issues
			if player.abilityselect == 5
				player.normalspeed = 30*FRACUNIT
				player.actionspd = 100*FRACUNIT
				player.runspeed = 24*FRACUNIT
				player.acceleration = 40
				player.accelstart = 64
				player.thrustfactor = 5
				player.jumpfactor = 1*FRACUNIT
				player.charability = CA_DOUBLEJUMP
				player.charability2 = CA2_SPINDASH
				if player.anycolor
					player.mo.color = SKINCOLOR_PINK
				end
			end
			
			-- shadow
			if player.abilityselect == 6
				player.normalspeed = 35*FRACUNIT
				player.actionspd = 100*FRACUNIT
				player.runspeed = 24*FRACUNIT
				player.acceleration = 43
				player.accelstart = 102
				player.thrustfactor = 4
				player.jumpfactor = 1*FRACUNIT
				player.charability = CA_HOMINGTHOK
				player.charability2 = CA2_SPINDASH
				if player.anycolor
					player.mo.color = SKINCOLOR_BLACK
				end
			end
			
			-- mecha sonic
			-- float ability was edited in 2.2 but i made mecha have the og behavior in a loop below
			if player.abilityselect == 7
				player.normalspeed = 36*FRACUNIT
				player.actionspd = 100*FRACUNIT
				player.runspeed = 34*FRACUNIT
				player.acceleration = 50
				player.accelstart = 70
				player.thrustfactor = 3
				player.jumpfactor = 1*FRACUNIT
				player.charability = CA_FLOAT
				player.charability2 = CA2_SPINDASH
				if player.anycolor
					player.mo.color = SKINCOLOR_GREY
				end
			end
			
			-- gamma
			-- added spindash to prevent issues, changed color to flame
			if player.abilityselect == 8
				player.normalspeed = 30*FRACUNIT
				player.actionspd = 100*FRACUNIT
				player.runspeed = 26*FRACUNIT
				player.acceleration = 40
				player.accelstart = 75
				player.thrustfactor = 4
				player.jumpfactor = 1*FRACUNIT
				player.charability = CA_SLOWFALL
				player.charability2 = CA2_SPINDASH
				if player.anycolor
					player.mo.color = SKINCOLOR_FLAME
				end
			end
			
			-- silver
			-- added spindash to prevent issues
			if player.abilityselect == 9
				player.normalspeed = 26*FRACUNIT
				player.actionspd = 100*FRACUNIT
				player.runspeed = 22*FRACUNIT
				player.acceleration = 50
				player.accelstart = 90
				player.thrustfactor = 5
				player.jumpfactor = 1*FRACUNIT
				player.charability = CA_TELEKINESIS
				player.charability2 = CA2_SPINDASH
				if player.anycolor
					player.mo.color = SKINCOLOR_SILVER
				end
			end
			
			-- espio
			if player.abilityselect == 10
				player.normalspeed = 34*FRACUNIT
				player.actionspd = 100*FRACUNIT
				player.runspeed = 30*FRACUNIT
				player.acceleration = 40
				player.accelstart = 96
				player.thrustfactor = 4
				player.jumpfactor = 1*FRACUNIT
				player.charability = CA_FALLSWITCH
				player.charability2 = CA2_SPINDASH
				if player.anycolor
					player.mo.color = SKINCOLOR_PURPLE
				end
			end
			
			-- blaze
			-- changed color to pastel because fang took lavender
			if player.abilityselect == 11
				player.normalspeed = 35*FRACUNIT
				player.actionspd = 100*FRACUNIT
				player.runspeed = 32*FRACUNIT
				player.acceleration = 43
				player.accelstart = 102
				player.thrustfactor = 4
				player.jumpfactor = 1*FRACUNIT
				player.charability = CA_AIRDRILL
				player.charability2 = CA2_SPINDASH
				if player.anycolor
					player.mo.color = SKINCOLOR_PASTEL
				end
			end
			
			-- real amy
			-- all new
			-- no jump spin flags are added in a separate loop below
			-- same with revitem/thokitem and mindash/maxdash
			if player.abilityselect == 12
				player.normalspeed = 36*FRACUNIT
				player.actionspd = 60*FRACUNIT
				player.runspeed = 28*FRACUNIT
				player.acceleration = 40
				player.accelstart = 96
				player.thrustfactor = 5
				player.jumpfactor = skins["amy"].jumpfactor
				player.charability = CA_TWINSPIN
				player.charability2 = CA2_MELEE
				if player.anycolor
					player.mo.color = SKINCOLOR_ROSY
				end
			end
			
			-- fang
			-- all new
			-- no jump spin flags are added in a separate loop below
			-- same with revitem and mindash/maxdash
			if player.abilityselect == 13
				player.normalspeed = 36*FRACUNIT
				player.actionspd = 60*FRACUNIT
				player.runspeed = 28*FRACUNIT
				player.acceleration = 40
				player.accelstart = 96
				player.thrustfactor = 5
				player.jumpfactor = skins["fang"].jumpfactor
				player.charability = CA_BOUNCE
				player.charability2 = CA2_GUNSLINGER
				if player.anycolor
					player.mo.color = SKINCOLOR_LAVENDER
				end
			end
			
			-- real metal sonic
			-- all new
			-- boost mode and multiability flags are added in a separate loop below
			if player.abilityselect == 14
				player.normalspeed = 36*FRACUNIT
				player.actionspd = 60*FRACUNIT
				player.runspeed = 28*FRACUNIT
				player.acceleration = 40
				player.accelstart = 96
				player.thrustfactor = 5
				player.jumpfactor = 1*FRACUNIT
				player.charability = CA_FLOAT
				player.charability2 = CA2_SPINDASH
				if player.anycolor
					player.mo.color = SKINCOLOR_COBALT
				end
			end
			
			-- made these separate to not add them one by one
			-- bust walls for knuckles
			if player.abilityselect == 3
				player.charflags = $|SF_CANBUSTWALLS
			else
				player.charflags = $&~SF_CANBUSTWALLS
			end
			-- boost mode and multiability for real metal
			if player.abilityselect == 14
				player.charflags = $|SF_DASHMODE
				player.charflags = $|SF_MULTIABILITY
			else
				player.charflags = $&~SF_DASHMODE
				player.charflags = $&~SF_MULTIABILITY
			end
			-- jump flags for amy and fang
			if player.abilityselect == 12
			or player.abilityselect == 13
				player.charflags = $|SF_NOJUMPSPIN
				player.charflags = $|SF_NOJUMPDAMAGE
			else
				player.charflags = $&~SF_NOJUMPSPIN
				player.charflags = $&~SF_NOJUMPDAMAGE
			end
			-- revitem replacements for amy and fang
			if player.abilityselect == 12
				player.revitem = MT_LHRT
			elseif player.abilityselect == 13
				player.revitem = MT_CORK
			else
				player.revitem = MT_NULL
			end
			-- thokitem replacement for amy
			if player.abilityselect == 12
				player.thokitem = MT_LHRT
			else
				player.thokitem = MT_THOK
			end
			-- mindash/maxdash replacement for amy/fang
			-- im not really sure of what mindash/maxdash does for fang but ill change it just in case
			if player.abilityselect == 12
				player.mindash = 2*FRACUNIT
				player.maxdash = 6*FRACUNIT
			elseif player.abilityselect == 13
				player.mindash = 1*FRACUNIT
				player.maxdash = 34*FRACUNIT
			else
				player.mindash = 15*FRACUNIT
				player.maxdash = 70*FRACUNIT
			end
			-- mecha sonic legacy float behavior
			if player.abilityselect == 7
			and(player.mo.state == S_PLAY_FLOAT
			or player.mo.state == S_PLAY_FLOAT_RUN)
				player.mo.momz = 0
			end
		end
	end
end)

-- i couldnt fix this so i had to cancel the ability in this situation
addHook("AbilitySpecial", function(player)
	if player.abilityselect == 7
	and player.speed == 0
		return true
	end
end)

addHook("MapLoad", function(mapnum)
	for player in players.iterate
	
		if player.abilitypicked == 1
			player.abilityselect = 0 //Reset when on a new map!
			player.abilitypicked = 0
		end

	end
end)